﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="HideFromUI.aspx.cs" Inherits="Automated_HideFromUI" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Hide Columns Nicely From UI</title>
    <script type="text/javascript">
        function changeVis(col) {
            debugger;
            col.set_hidden(true);
        }

        function changeColVis(checkbox, visIndex) {
            var grid = $find("WebDataGrid1");
            var col = grid.get_columns().get_column(visIndex);
            if (visIndex != col.get_visibleIndex()) {
                for (var y = 0; y < grid.get_columns().get_length(); ++y) {
                    var tempCol = grid.get_columns().get_column(y);
                    if (y == tempCol.get_visibleIndex()) {
                        col = tempCol;
                        break;
                    }
                }
            }
            col.set_hidden(!checkbox.checked);
        }
        

        function showMenu(grid, args) {
            //debugger;
            var div = document.getElementById("visMenuDiv");
            if (args.get_type() != "header") {
                div.style.display = "none";
                div.style.visibility = "hidden";
                return;
            }

            var ul;
            for (var x = 0; x < div.childNodes.length; ++x) {
                if (div.childNodes[x].tagName && (div.childNodes[x].tagName == "ul" || div.childNodes[x].tagName == "UL")) {
                    ul = div.childNodes[x];
                    break;
                }
            }
            if (!ul)
                return;
            var grid = $find("WebDataGrid1");
            var index = 0;
            for (var x = 0; x < grid.get_columns().get_length(); ++x) {
                var col = grid.get_columns().get_column(x);
                if (x != col.get_visibleIndex()) {
                    for (var y = 0; y < grid.get_columns().get_length(); ++y) {
                        var tempCol = grid.get_columns().get_column(y);
                        if (y == tempCol.get_visibleIndex()) {
                            col = tempCol;
                            break;
                        }
                    }
                }
                var li = ul.childNodes[index];
                while (!(li.tagName && (li.tagName == "li" || li.tagName == "LI"))) {
                    ++index;
                    li = ul.childNodes[index];
                }
                ++index;
                var checkbox = li.childNodes[0];
                checkbox.checked = !col.get_hidden(true);
                //debugger;
                li.childNodes[1].textContent = col.get_key();
            }

			// will need to adjust positioning most likely
            var el = args.get_item().get_element();
            div.style.top = (el.offsetTop + el.offsetHeight * 2) + "px";
            div.style.left = el.offsetLeft + "px";
            div.style.display = "";
            div.style.visibility = "visible";
            
        }

        function hideMenu() {
            document.getElementById("visMenuDiv").style.display = "none";
            document.getElementById("visMenuDiv").style.visibility = "hidden";
        }

    
    </script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <ig:WebDataGrid ID="WebDataGrid1" runat="server" Width="400px" Height="350px"
            DataSourceID="AccessDataSource1" AutoGenerateColumns="false" ShowFooter="true">
            <ClientEvents ContextMenu="showMenu" />
            <Columns>
                <ig:BoundDataField Key="Id" DataFieldName="Id" Width="100px">
                    <Header Text="Id" />
                    <Footer Text="ident" />
                </ig:BoundDataField>
                <ig:BoundDataField Key="BirthDate" DataFieldName="BirthDate" Width="100px">
                    <Header Text="BirthDate" />
                    <Footer Text="Happy Bday!" />
                </ig:BoundDataField>
                <ig:BoundDataField Key="Name" DataFieldName="Name" Width="100px">
                    <Header Text="Name" />
                    <Footer Text="nombre" />
                </ig:BoundDataField>
                <ig:BoundDataField Key="GlobalId" DataFieldName="GlobalId" Width="100px">
                    <Header Text="GlobalId" />
                    <Footer Text="global" />
                </ig:BoundDataField>
                <ig:BoundDataField Key="IsActive" DataFieldName="IsActive" Width="100px">
                    <Header Text="IsActive" />
                    <Footer Text="activate" />
                </ig:BoundDataField>
                <ig:BoundDataField Key="Salary" DataFieldName="Salary" Width="100px">
                    <Header Text="Salary" />
                    <Footer Text="$$$" />
                </ig:BoundDataField>
            </Columns>
        </ig:WebDataGrid>
        
        <asp:Button ID="PostbackBtn" runat="server" Text="Postback" 
            onclick="PostbackBtn_Click" />
        <input type="button" value="click" onclick="createDiv()" />
        <input type="button" value="show menu" onclick="showMenu()" />
        
        <div id="visMenuDiv" style="display:none; position:absolute; z-index:10000; background-color: White; ">
            <span>Visible Columns</span>
            <ul style="list-style-type:none; border: 1px Black; z-index: 10000;">
                <li><input type="checkbox" id="hiddenCheckBox_0" onclick="changeColVis(this, 0)" /><span>Id</span></li>
                <li><input type="checkbox" id="hiddenCheckBox_1" onclick="changeColVis(this, 1)" /><span>BirthDate</span></li>
                <li><input type="checkbox" id="hiddenCheckBox_2" onclick="changeColVis(this, 2)" /><span>Name</span></li>
                <li><input type="checkbox" id="hiddenCheckBox_3" onclick="changeColVis(this, 3)" /><span>GlobalId</span></li>
                <li><input type="checkbox" id="hiddenCheckBox_4" onclick="changeColVis(this, 4)" /><span>IsActive</span></li>
                <li><input type="checkbox" id="hiddenCheckBox_5" onclick="changeColVis(this, 5)" /><span>Salary</span></li>
            </ul>
            <input type="button" id="closeMenuBtn" onclick="hideMenu()" value="Close" />
        </div>
    
        <asp:AccessDataSource ID="AccessDataSource1" runat="server" 
            DataFile="~/App_Data/SampleDatabase.mdb" 
            SelectCommand="SELECT [Id], [BirthDate], [Name], [GlobalId], [IsActive], [Salary] FROM [Person]" >
        </asp:AccessDataSource>
    </div>
    
    <asp:ScriptManager ID="ScriptManager1" runat="server">
    </asp:ScriptManager>
    
    </form>
</body>
</html>
